'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _applyDelta = require('./apply-delta');

var _applyDelta2 = _interopRequireDefault(_applyDelta);

var _batcher = require('./batcher');

var _batcher2 = _interopRequireDefault(_batcher);

var _get2 = require('./get');

var _get3 = _interopRequireDefault(_get2);

var _getRaw2 = require('./get-raw');

var _getRaw3 = _interopRequireDefault(_getRaw2);

var _queryToPaths = require('./query-to-paths');

var _queryToPaths2 = _interopRequireDefault(_queryToPaths);

var _resolvePath = require('./resolve-path');

var _resolvePath2 = _interopRequireDefault(_resolvePath);

var _router = require('./router');

var _router2 = _interopRequireDefault(_router);

var _triggerWatchers = require('./trigger-watchers');

var _triggerWatchers2 = _interopRequireDefault(_triggerWatchers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Store = function () {
  function Store() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$batchDelay = _ref.batchDelay,
        delay = _ref$batchDelay === undefined ? 0 : _ref$batchDelay,
        _ref$cache = _ref.cache,
        cache = _ref$cache === undefined ? {} : _ref$cache,
        _ref$router = _ref.router,
        router = _ref$router === undefined ? new _router2.default() : _ref$router;

    _classCallCheck(this, Store);

    this.batcher = new _batcher2.default({ delay: delay, router: router, store: this });
    this.cache = cache;
    this.router = router;
    this.watchers = {};
    this.watcherIndex = 0;
  }

  _createClass(Store, [{
    key: 'get',
    value: function get(path) {
      return (0, _get3.default)(this.cache, path);
    }
  }, {
    key: 'getRaw',
    value: function getRaw(path) {
      return (0, _getRaw3.default)(this.cache, path);
    }
  }, {
    key: 'resolve',
    value: function resolve(path) {
      return (0, _resolvePath2.default)(this.cache, path);
    }
  }, {
    key: 'run',
    value: function run(options) {
      return this.batcher.run(options);
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      return this.batcher.destroy();
    }
  }, {
    key: 'update',
    value: function update(delta) {
      var prev = this.cache;

      var next = this.cache = (0, _applyDelta2.default)(prev, delta);
      if (next !== prev) (0, _triggerWatchers2.default)(this.watchers, prev, next, delta);
      return this;
    }
  }, {
    key: 'watch',
    value: function watch(query, cb) {
      this.unwatch(cb);
      this.watchers[++this.watcherIndex] = { paths: (0, _queryToPaths2.default)(query), cb: cb };
      return this;
    }
  }, {
    key: 'unwatch',
    value: function unwatch(cb) {
      var watchers = this.watchers;


      for (var i in watchers) {
        if (!cb || watchers[i].cb === cb) delete watchers[i];
      }

      return this;
    }
  }]);

  return Store;
}();

exports.default = Store;
